/************************************************
* MENU.C - menu handler subroutine				*
*												*
* INP:	m - menu descriptor						*
* OUT:	0 (if escape key was pressed), or the	*
*		number of the selection chosen			*
* NOTE:	No error checking is performed during	*
*		display.								*
************************************************/

#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#include "menu.h"

int Dcount(char *s)
	{
	int r;

	for (r=0; *s != '\0'; s++)
		if (*s == '\1')
			++r;
	return r;
	}

int Dstrlen(char *s)
	{
	int r;

	for (r=0; *s && *s!='\1'; r++,s++)
		;
	return r;
	}

void Dcputs(char *s)
	{
	static char buf[80];
	int cnt;

	for (cnt=0 ; *s && *s!='\1'; s++)
		buf[cnt++]=*s;
	buf[cnt]=0;
	cputs(buf);
	}

int menu(MENU *m)
	{
	int  hc, tc, cc, i, max, tmp;
	char *t, rsp[CRT_WIDTH-26+2];

	textbackground(BLUE);
	clrscr();

	/* Count heading lines, text lines & choices*/
	hc = Dcount(m->hdr)+1;
	tc = Dcount(m->text)+1;
	cc = Dcount(m->choice)+1;

	/* Draw the heading */
	textcolor(YELLOW);
	for (i=0,t=m->hdr; i<hc; i++)
		{
		gotoxy((CRT_WIDTH-Dstrlen(t))/2,i+1);
		Dcputs(t);
		t+=Dstrlen(t)+1;
		}

	/* Draw the text lines */
	textcolor(WHITE);
	for (i=0,t=m->text,max=0; i<tc; i++)
		{
		tmp = Dstrlen(t);
		if (tmp > max) max=tmp;
		t += tmp+1;
		}
	tmp = (CRT_PRMPT-hc-tc)/2 + hc;
	for (i=0,t=m->text; i<tc; i++)
		{
		gotoxy((CRT_WIDTH-max)/2,i+tmp);
		Dcputs(t);
		t+=Dstrlen(t)+1;
		}

	/* Find length of maximum response */
	for (i=0,t=m->choice,max=0; i<cc; i++)
		{
		tmp = Dstrlen(t);
		if (tmp > max) max=tmp;
		t += tmp+1;
		}
	if (max>CRT_WIDTH-26) max=CRT_WIDTH-26;
	if (max<5) max=5;
	rsp[0] = max;

	for (tmp=-1; tmp<0; )
		{
		/* Get the user's response */
		textcolor(YELLOW);
		gotoxy(1,24);
		clreol();
		cputs("Please enter your choice: ");
		cgets(rsp);

		/* Check if response is valid */
		for (i=0,t=m->choice,max=0; i<cc; i++)
			{
			if (!strncmp(rsp+2,t,rsp[1]))
				tmp=i;
			t += Dstrlen(t)+1;
			}
		gotoxy(1,25);
		clreol();
		if (tmp < 0)
			{			/* Nope ... invalid */
			sound(440);
			textcolor(BLINK+LIGHTRED);
			cputs(rsp+2);
			cputs(" is not a legal choice!");
			delay(100);
			nosound();
			}
		}

	/* Return the appropriate value */
	for (i=0,t=m->response; i<cc; i++)
		{
		if (i==tmp)
			{
			tmp=atoi(t);
			i=cc+1;
			}
		t += Dstrlen(t)+1;
		}
	return tmp;
	}
